#include <stdio.h>
#include <stdlib.h>
#include "iocrema.h"

/* numero di elemnti del vettore di puntatori */
#define N 100

/* usato per la stampa parziale */
#define NUMVAL 10

int main()
{
  int *p[N];
  int i;

  printf("N: %d\n", N);
  for (i=0; i<N; i++)
    {
      p[i] = (int *) calloc(1, sizeof(int));
      
      if (p[i] != NULL)
        {
	  *p[i] = i+1;
        }
      else
        {
	  StampaStringa("ERRORE: Dimensione troppo grande");
	  StampaStringa("non posso allocare l'elemento ");
	  StampaIntero(i);
	  ACapo();
	  return 1;
        }
    }

  /* stampa tutti gli elementi */
  for (i=0; i<N; i++)
    {
      StampaIntero(*p[i]);
      StampaStringa(" ");
    }
  ACapo();

  /* Stampa alternativa: visualizza solo NUMVAL elementi equidistribuiti */
  double step = (N<=NUMVAL ? 1 : (double)(N-1)/(NUMVAL-1));
  for (i=0; i<NUMVAL; i++)
    {
      int istep = i*step;
      if (istep < N) {
	StampaIntero(*p[istep]);
	if (step > 1 && i < NUMVAL-1)
	  StampaStringa(" ... ");
	StampaStringa(" ");
      }
    }
  ACapo();

  /* rilascia la memoria allocata */
  for (i=0; i<N; i++)
    free(p[i]);
  
  return 0;
}
