#include <stdio.h>
#include <stdlib.h>
#include "iocrema.h"

/* numero di elementi del vettore di puntatori */
#define N 90

/* numero di multipli da elencare */
#define M 10

int main()
{
  int **p;
  int i, j;

  printf("N: %d  M: %d\n", N, M);
  
  /* allocazione del vettore di puntatori a int */
  p = (int **) calloc(N, sizeof(int *));
  if (p == NULL) {
    StampaStringa("ERRORE: Dimensione troppo grande");
    ACapo();
    StampaStringa("Non posso allocare p ");
    ACapo();
    return 2;
  }

  for (i=0; i<N; i++)
    {
      p[i] = (int *) calloc(M, sizeof(int));
      
      if (p[i] != NULL)
        {
	  for (j=0; j<M; j++) {
	    /* p[i] è un puntatore ad intero: lo si puo' usare come 
	       se fosse il nome di un vettore e accedere all'elemento j-esimo
	       con la notazione p[i][j]
	    */
	    p[i][j] = (i+1)*(j+1);
	  }
        }
      else
        {
	  StampaStringa("ERRORE: Dimensione troppo grande");
	  StampaStringa("non posso allocare l'elemento ");
	  StampaIntero(i);
	  ACapo();
	  return 1;
        }
    }

  /* stampa tutti gli elementi */
  for (i=0; i<N; i++)
    {
      for (j=0; j<M; j++)
	{
	  StampaIntero(p[i][j]);
	  StampaStringa(" ");
	}
      ACapo();
    }
  
  
  /* rilascia la memoria allocata */
  for (i=0; i<N; i++)
     free(p[i]);
  free(p);
  
  return 0;
}
